#include <stdio.h>
#include <stdlib.h>

#include "bignum.h"


void
test_cmp()
{
	struct bignum a, b;
	unsigned short av[] = { 0xffff, 0xffff };
	unsigned short bv[] = { 0x0000, 0xffff };
	unsigned short aav[] = { 0xffff, 0xffff, 0xffff };
	unsigned short bbv[] = { 0xaaaa };
	unsigned short zero[] = { 0x0000 };

	bnum_init_static(&a);
	bnum_init_static(&b);

	
	bnum_set(&a, bbv, 1, 1);
	bnum_set(&b, zero, 1, 0);
	
	printf("-0xaaaa > 0x0 ? %d\n", bnum_cmp(&a, &b));
	
	bnum_set(&a, bbv, 1, 0);
	bnum_set(&b, zero, 1, 0);
	
	printf("0xaaaa > 0x0 ? %d\n", bnum_cmp(&a, &b));
	
	bnum_set(&a, av, 2, 0);
	bnum_set(&b, bv, 2, 0);
	
	printf("0xffffffff > 0xffff0000 ? %d\n", bnum_cmp(&a, &b));

	bnum_set(&a, av, 2, 1);
	bnum_set(&b, bv, 2, 0);

	printf("-0xffffffff > 0xffff0000 ? %d\n", bnum_cmp(&a, &b));

	bnum_set(&a, av, 2, 0);
	bnum_set(&b, bv, 2, 1);

	printf("0xffffffff > -0xffff0000 ? %d\n", bnum_cmp(&a, &b));

	bnum_set(&a, zero, 1, 1);
	bnum_set(&b, zero, 1, 0);

	printf("-0x0 > 0x0 ? %d\n", bnum_cmp(&a, &b));

	bnum_set(&a, zero, 1, 0);
	bnum_set(&b, zero, 1, 0);

	printf("0x0 > 0x0 ? %d\n", bnum_cmp(&a, &b));

	bnum_set(&a, aav, 1, 0);
	bnum_set(&b, bbv, 1, 0);

	printf("0xffffffffffff > 0xaaaa ? %d\n", bnum_cmp(&a, &b));

	bnum_set(&a, aav, 3, 1);
	bnum_set(&b, bbv, 1, 0);

	printf("-0xffffffffffff > 0xaaaa ? %d\n", bnum_cmp(&a, &b));

	bnum_set(&a, aav, 3, 0);
	bnum_set(&b, bbv, 1, 1);

	printf("0xffffffffffff > -0xaaaa ? %d\n", bnum_cmp(&a, &b));

	bnum_reset(&a);
	bnum_reset(&b);
}

int
main(int argc, char **argv)
{
	test_cmp();

	return 0;
}
